const app = getApp()
import WxValidate from '../../utils/wxValidate'
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '自动编排组项信息', leftArrow: true, useBar: false },
        bg: '/image/bg.png',
        form: {},
        // 赛事信息
        matchList: [],
        // 组别
        groupingList: [],
        //组内项目
        projectList: [],
        list: []
    },
    initValidate() {
        const rules = { match_id: { required: true }, grouping_id: { required: true }, project_id: { required: true }, team_number: { required: true } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { match_id: { required: '请选择赛事名称', }, grouping_id: { required: '请选择赛事组别', }, project_id: { required: '请选择组内项目', }, team_number: { required: '请输入分组数' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    back(e) { wx.navigateBack({ delta: 1 }) },
    // 选择赛事
    matchChange: function (e) {
        const that = this;
        let data = that.data.matchList[e.detail.value];
        if (data) {
            that.setData({ 'form.match_id': data._id });
            that.setData({ 'form.match_name': data.name });
            if (data.grouping && data.grouping.length > 0) {
                that.setData({ groupingList: data.grouping })
            }
        }
    },
    // 选择赛事组别
    grpupChange: async function (e) {
        const that = this;
        let data = that.data.groupingList[e.detail.value];
        if (data) {
            that.setData({ 'form.grouping_id': data._id });
            that.setData({ 'form.grouping_name': data.name });
            if (data.project && data.project.length > 0) {
                let projectList = [];
                for (const val of data.project) {
                    const arr = await app.$get(`/newCourt/api/matchProject/${val}`)
                    if (arr.errcode == '') projectList.push(arr.data);
                    that.setData({ projectList: projectList })
                }
            }
        }
    },
    // 选择组内项目
    projectChange: function (e) {
        const that = this;
        let data = that.data.projectList[e.detail.value];
        if (data) {
            that.setData({ 'form.project_id': data._id });
            that.setData({ 'form.project_name': data.name });
        }
    },
    // 组删除
    teamDel: function (e) {
        const that = this;
        let list = that.data.list;
        const { item } = e.currentTarget.dataset;
        list = list.filter((i) => i.name != item.name);
        that.setData({ list: list })
    },
    // 删除组成员
    personDel: async function (e) {
        const that = this;
        let list = that.data.list;
        const { group, tag } = e.currentTarget.dataset;
        let type = '';
        const project = await app.$get(`/newCourt/api/matchProject/${group.project_id}`);
        if (project.errcode == '0') { type = project.data.type };
        if (type == '单打') {
            for (const val of list) {
                if (val.name == group.name) { val.person = val.person.filter((i) => i.openid != tag.openid) }
            }
        } else if (type == '双打') {
            for (const val of list) {
                if (val.name == group.name) { val.person = val.person.filter((i) => i.team_id != tag.team_id) }
            }
        }
        that.setData({ list: list })
    },
    // 一键保存
    onekeySubmit: async function () {
        const that = this;
        const params = that.data.list;
        const arr = await app.$post(`/newCourt/api/raceTeam/saveAll`, params);
        if (arr.errcode == '0') {
            wx.showToast({ title: `保存成功`, icon: 'success', duration: 2000 });
            that.back()
        } else {
            wx.showToast({ title: `${arr.errmsg}`, icon: 'fail', duration: 2000 });
        }
    },
    // 提交保存
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            const arr = await app.$post(`/newCourt/api/raceTeam/auto`, params);
            if (arr.errcode == '0') { that.setData({ list: arr.data }) }
            else { wx.showToast({ title: `${arr.errmsg}`, icon: 'none', duration: 2000 }) }
        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        that.setData({ id: options.id || '' });
        //验证规则函数
        that.initValidate();
        that.onShow()
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        const that = this;
        that.watchLogin()
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                const arr = await app.$get(`/newCourt/api/match`, { status: '0' });//2
                if (arr.errcode == '0') {
                    that.setData({ matchList: arr.data });
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})